unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, inifiles, ExtCtrls, shellapi, Buttons, unitx;


const
  rcvsize=10000;
  flag0: byte = 16;
  flag1: byte = 0;

  cmdlength = 10;
  echocmd = #0;
  infocmd = #1;
  setstatus = #2;
  getstatus = #3;
  setirbitcode=#4;
  sendircode=#5;
  device_reset=#6;
  read_eprom=#7;
  write_eprom=#8;
  sendepromircode=#9;
  Get_Temperature=#10;
  Set_DS18Cfg=#11;
  Get_DS18Rom=#12;
  sendeprgircode=#13;

  IRkhz: string = '';

  // flag0
  ir_30kHz = 1;
  ir_33kHz = 2;
  ir_36kHz = 4;
  ir_37kHz = 8;   // 36,7kHz
  ir_38kHz = 16;
  ir_40kHz = 32;
  ir_56kHz = 64;

// flag1
  ir_repeat = 1;
  ir_sw_rep = 2;
  ir_sndLoHi = 4;
  ir_sndHiLo = 8;
  ir_kHz = 16;
  ir_det_Hz = 64;
  ir_irda_rep = 128;

type

  rcvbuf = array [0..rcvsize] of char;
  tshowdata=(shhex,shbinary,shascii);

  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    ir1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Info1: TMenuItem;
    N2: TMenuItem;
    echo1: TMenuItem;
    Decodeline1: TMenuItem;
    PopupMenu1: TPopupMenu;
    AddToHiTimer1: TMenuItem;
    N9: TMenuItem;
    DecodeGraph1: TMenuItem;
    RepeaterTSOP1: TMenuItem;
    od: TOpenDialog;
    Getstatus1: TMenuItem;
    Temperature1: TMenuItem;
    Gettemperature1: TMenuItem;
    GetROMdata1: TMenuItem;
    SetConfiguration1: TMenuItem;
    Device1: TMenuItem;
    Setfrequencie1: TMenuItem;
    N30kHz1: TMenuItem;
    N33kHz1: TMenuItem;
    N36kHz1: TMenuItem;
    N37kHz1: TMenuItem;
    N38kHz1: TMenuItem;
    N40kHz1: TMenuItem;
    N56kHz1: TMenuItem;
    Detectfrequency1: TMenuItem;
    DectectIRcode1: TMenuItem;
    SendIRcode1: TMenuItem;
    Reset1: TMenuItem;
    RepeaterIRDA1: TMenuItem;
    SendEpromIRcode1: TMenuItem;
    SendFlashIRcode1: TMenuItem;
    N4: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure echo1Click(Sender: TObject);
    procedure Decodeline1Click(Sender: TObject);
    procedure AddToHiTimer1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure DecodeGraph1Click(Sender: TObject);
    procedure Getstatus1Click(Sender: TObject);
    procedure Gettemperature1Click(Sender: TObject);
    procedure GetROMdata1Click(Sender: TObject);
    procedure SetConfiguration1Click(Sender: TObject);
    procedure Detectfrequency1Click(Sender: TObject);
    procedure DectectIRcode1Click(Sender: TObject);
    procedure RepeaterTSOP1Click(Sender: TObject);
    procedure SendIRcode1Click(Sender: TObject);
    procedure N30kHz1Click(Sender: TObject);
    procedure N33kHz1Click(Sender: TObject);
    procedure N36kHz1Click(Sender: TObject);
    procedure N37kHz1Click(Sender: TObject);
    procedure N38kHz1Click(Sender: TObject);
    procedure N40kHz1Click(Sender: TObject);
    procedure N56kHz1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure RepeaterIRDA1Click(Sender: TObject);
    procedure SendEpromIRcode1Click(Sender: TObject);
    procedure SendFlashIRcode1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   procedure AddStrX(s:string);
   function openport: boolean;
   procedure SendCmd(cmd: string; chars: byte);
   procedure GetTemperature;
   procedure UncheckkHz;
   procedure SetMenuCheck(dfq,dic,ret,rei: boolean);
   procedure UpdateMenu(f0,f1: byte);
  end;

var

  Form1: TForm1;
  nrcv: cardinal;

implementation

uses Unit3, crc8;

{$R *.DFM}

var
  comhandle: thandle= 0;
  readthread: treadthread = nil;
  rcv: rcvbuf;
  portopen: boolean = false;
  showdata: tshowdata = shhex;
  showcrlf: boolean = false;
  showlog: boolean = true;
  autoopen: boolean = true;
  loglines: integer = 100;
  UpdateMenuFromStatus: boolean = true;


constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;




function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 3/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;

function doopenport(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: TIniFile;
    c: string;
    brate: integer;
const init='init';
begin
 result := false;
 f := tinifile.create(_exedir+_exename+'.ini');
try
 c := uppercase(f.ReadString(init,'port','\\.\COM1'));
 brate := f.ReadInteger(init,'baud',115200);

finally
 f.free;
end;
 ph := CreateFile(pchar(c),
    GENERIC_READ or GENERIC_WRITE, 0,nil,
    OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+syserrormessage(GetLastError));
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;
 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
   exit;
  end;
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.openport: boolean;
begin

 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;

 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 if not doopenport(comhandle) then exit;

 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '+syserrormessage(getlasterror)+#13+syserrormessage(GetLastError));
 end;

 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;

 result := true;
 portopen := true;
 addstr('COM port opened');
 wdelay(1000); // wait for power is stable
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
begin
 if not showlog then exit;
 m.lines.BeginUpdate;
try
// while m.lines.count > loglines do begin
//  m.Lines.Delete(m.lines.count-1);
// end;
 m.lines.insert(0,trimright(s));
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.AddStrX(s:string);
var l: boolean;
begin
 l := showlog;
 showlog := true;
 AddStr(s);
 showlog := l;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('IR analyser/sender/repeater'#13#13'(c) Zelenka 2010');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
begin
 sb1.Panels[1].text := '';
 if not portopen then openport;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
// addstr('S: '+p)
 addstr('S: '+inttostr(length(cmd))+'B');
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].Text := p;
end;



function GetSpecialName(ShortCut: TShortCut): string;
var
  ScanCode: Integer;
  KeyName: array[0..255] of Char;
begin
  Result := '';
  ScanCode := MapVirtualKey(WordRec(ShortCut).Lo, 0) shl 16;
  if ScanCode <> 0 then
  begin
    GetKeyNameText(ScanCode, KeyName, SizeOf(KeyName));
    GetSpecialName := KeyName;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
const init='init';
begin
 od.InitialDir := _exedir;
 decimalseparator := '.';
 m.Clear;

 f := tinifile.create(_exedir+_exename+'.ini');
try
 autoopen := f.ReadBool(init,'autoopen',autoopen);
 loglines := f.ReadInteger(init,'loglines',loglines);
 UpdateMenuFromStatus := f.ReadBool(init,'UpdateMenuFromStatus',UpdateMenuFromStatus);
finally
 f.free;
end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 openport;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  if autoopen then openport;
 end;
end;

procedure TForm1.echo1Click(Sender: TObject);
var s: string;
begin
 s := echocmd+#1#2#3#4#5#6#7#8#9;
 SendCmd(s,cmdlength+2);
 s := s + #13#10;
end;

procedure TForm1.Info1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(infocmd,34);
 showdata := b;
end;

procedure TForm1.Reset1Click(Sender: TObject);
begin
 if qbox('Are you sure?') <> idyes then exit;
 SendCmd(device_reset,2);
end;

procedure TForm1.Decodeline1Click(Sender: TObject);
begin
 Form3.show;
end;

procedure TForm1.AddToHiTimer1Click(Sender: TObject);
begin
 if trim(m.SelText) <> '' then begin
  form3.data.Text := m.SelText;
  form3.show;
//  self.Show;
 end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 form3.show;
 form3.BitBtn5Click(Sender);
end;

procedure TForm1.DecodeGraph1Click(Sender: TObject);
begin
 BitBtn3Click(Sender);
end;

procedure TForm1.UpdateMenu(f0,f1: byte);
begin
 UncheckkHz;
 IRkhz := '';
 flag0 := f0;
 case f0 of
  ir_30kHz: begin N30kHz1.Checked := true; IRkhz := '30kHz'; end;
  ir_33kHz: begin N33kHz1.Checked := true; IRkhz := '33kHz'; end;
  ir_36kHz: begin N36kHz1.Checked := true; IRkhz := '36kHz'; end;
  ir_37kHz: begin N37kHz1.Checked := true; IRkhz := '37kHz'; end;
  ir_38kHz: begin N38kHz1.Checked := true; IRkhz := '38kHz'; end;
  ir_40kHz: begin N40kHz1.Checked := true; IRkhz := '40kHz'; end;
  ir_56kHz: begin N56kHz1.Checked := true; IRkhz := '56kHz'; end;
 end;
 sb1.Panels[0].Text := ' '+IRkhz+' ';
 Detectfrequency1.Checked := f1 and ir_det_Hz <> 0;
 DectectIRcode1.Checked := f1 and (ir_sndLoHi + ir_sndHiLo) <> 0;
 RepeaterTSOP1.Checked := f1 and ir_sw_rep <> 0;
 RepeaterIRDA1.Checked := f1 and ir_irda_rep <> 0;
end;

procedure TForm1.Getstatus1Click(Sender: TObject);
var b: tshowdata;
    f: real;
    i: integer;
    h,l: byte;
begin
 b := showdata;
 showdata := shhex;
 SendCmd(getstatus,47);
 if nrcv = 47 then begin
  addstr('');
  for i := 0 to 19 do begin
   h := byte(rcv[i*2+5]);
   l := byte(rcv[i*2+6]);
   f := 0.0000000904224537037*(h*256+l);
   if f > 0 then f := 1/f;
   f := f/1000; // kHz
//   if (f > 25) and (f < 60) then begin
    addstr(format('IR Hi:%3d, Lo:%3d, F=%9.3f kHz',[byte(rcv[i*2+5]),byte(rcv[i*2+6]),f]));
//   end else begin
//    addstr(format('IR Hi:%3d, Lo:%3d, Invalid frequency',[byte(rcv[i*2+5]),byte(rcv[i*2+6])]));
//   end;
  end;
  addstr(format('PortB: %s PortD: %s',[binb(byte(rcv[1])),binb(byte(rcv[2]))]));
  addstr(format('Flag0: %s Flag1: %s',[binb(byte(rcv[3])),binb(byte(rcv[4]))]));
  if UpdateMenuFromStatus then updatemenu(byte(rcv[3]),byte(rcv[4])) else begin
  end;
 end;
 showdata := b;
end;

procedure TForm1.GetTemperature;
var t: record
     LSB, MSB, UserTH, UserTL,CONFIG,Res1,Res2,Res3,CRC,error: byte;
     sign: boolean;
    end;
    s,sc: string;
    crc,bl,bh: byte;
    i: integer;
begin
 sc := '';
 SendCmd(Get_Temperature,12);
 if nrcv >= 12 then begin
  move(rcv,t,sizeof(t)-1);
  t.sign := false;
  if t.MSB > 15 then begin  // minus
   sc := '-';
   t.sign := true;
   t.MSB := not t.MSB + 1;
   t.LSB := not t.LSB + 1;
  end;

  s := '';
  for i := 0 to 7 do s := s+rcv[i];
  crc := CalcCRC8(s);

  bh := (t.MSB shl 4) + (t.LSB and $F0) shr 4;
  bl := t.LSB and $F;
  if t.error <> 0 then begin
   s := 'Temperature read error!';
  end else begin
   addstr('');
   s := format('Temperature: %s%0.2f C',[sc,bh+bl*0.0625]);
   if crc <> t.CRC then addstr('CRC Error!'); // else addstr('CRC OK!')
  end;

(*
DS18B20 CONFIGURATION REGISTER
=======================================================
MSb 0 R1 R0 1 1 1 1 1 LSb

Thermometer Resolution Configuration Table
=======================================================
R1 R0   Thermometer Resolution   Max Conversion Time
0  0          9 bit                93.75 ms (tconv/8)
0  1         10 bit               187.5 ms (tconv/4)
1  0         11 bit               375 ms (tconv/2)
1  1         12 bit               750 ms (tconv)

TEMPERATURE DIGITAL OUTPUT
=======================================================
2^3 2^2 2^1 2^0 2^-1 2^-2 2^-3 2^-4 LSB
S   S   S   S   S    2^6  2^5  2^4  MSB

DIGITAL     (Binary)           (Hex)
+125C      0000 0111 1101 0000 07D0h
+ 85C      0000 0101 0101 0000 0550h*
+ 25.0625C 0000 0001 1001 0001 0191h
+ 10.125C  0000 0000 1010 0010 00A2h
+  0.5C    0000 0000 0000 1000 0008h
   0C      0000 0000 0000 0000 0000h
-  0.5C    1111 1111 1111 1000 FFF8h
- 10.125C  1111 1111 0101 1110 FF5Eh
- 25.0625C 1111 1110 0110 1111 FF6Fh
- 55C      1111 1100 1001 0000 FC90h
*)

  addstr(s);
  addstr(format('Config byte: %s',[binb(t.config)]));
  addstr(format('User TH: %d User TL: %d',[t.UserTH,t.UserTL]));
 end;
end;

procedure TForm1.Gettemperature1Click(Sender: TObject);
begin
 GetTemperature;
end;

procedure TForm1.GetROMdata1Click(Sender: TObject);
var s: string;
    i: integer;
    crc: byte;
begin
 SendCmd(Get_DS18Rom,12);
 if nrcv >= 12 then begin
  s := '';
  for i := 0 to 6 do s := s+rcv[i];
  crc := CalcCRC8(s);
  if crc <> byte(rcv[7]) then addstr('CRC Error!');
 end;
end;

function GetBinary(b: string): byte;
var i,l: byte;
begin
 b := '00000000'+b;
 i := length(b);
 b := copy(b,i-7,8);
 l := 0;
 for i := 7 downto 0 do
  begin
   if b[8-i] = '1' then l := l + (1 shl i);
  end;
 GetBinary := l;
end;

procedure TForm1.SetConfiguration1Click(Sender: TObject);
var uh,ul,c: byte;
begin
 if qbox('Are you sure?') <> idyes then exit;
 uh := 0; ul := 0; c := GetBinary('01111111');
 SendCmd(Set_DS18Cfg+chr(uh)+chr(ul)+char(c),2);
end;

procedure TForm1.SetMenuCheck(dfq,dic,ret,rei: boolean);
begin
 Detectfrequency1.Checked := dfq;
 DectectIRcode1.Checked := dic;
 RepeaterTSOP1.Checked := ret;
 RepeaterIRDA1.Checked := rei;
end;

procedure TForm1.Detectfrequency1Click(Sender: TObject);
begin
 Detectfrequency1.Checked := not Detectfrequency1.checked;
 if Detectfrequency1.checked then begin
  SetMenuCheck(true,false,false,RepeaterIRDA1.checked);
  flag1 := flag1 and not (ir_sndLoHi + ir_sndHiLo);
  flag1 := flag1 and not ir_sw_rep;
  flag1 := flag1 or ir_det_Hz;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end else begin
  RepeaterIRDA1.checked := false;
  flag1 := flag1 and not ir_det_Hz;
  flag1 := flag1 and not ir_irda_rep;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end;
end;

procedure TForm1.DectectIRcode1Click(Sender: TObject);
begin
 DectectIRcode1.Checked := not DectectIRcode1.checked;
 if DectectIRcode1.checked then begin
  SetMenuCheck(false,true,RepeaterTSOP1.checked,false);
  flag1 := flag1 and not ir_det_Hz;
  flag1 := flag1 and not ir_irda_rep;
  flag1 := flag1 or (ir_sndLoHi + ir_sndHiLo);
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end else begin
  flag1 := flag1 and not (ir_sndLoHi + ir_sndHiLo);
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end;
end;

procedure TForm1.RepeaterTSOP1Click(Sender: TObject);
begin
 RepeaterTSOP1.Checked := not RepeaterTSOP1.checked;
 if RepeaterTSOP1.checked then begin
  SetMenuCheck(false,DectectIRcode1.checked,true,false);
  flag1 := flag1 and not ir_det_Hz;
  flag1 := flag1 and not ir_irda_rep;
  flag1 := flag1 or ir_sw_rep;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end else begin
  flag1 := flag1 and not ir_sw_rep;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end;
end;

procedure TForm1.RepeaterIRDA1Click(Sender: TObject);
begin
 RepeaterIRDA1.Checked := not RepeaterIRDA1.checked;
 if RepeaterIRDA1.checked then begin
  SetMenuCheck(true,false,false,true);
  flag1 := ir_det_Hz + ir_irda_rep;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end else begin
  flag1 := (flag1 and not ir_irda_rep); // and not ir_det_Hz;
  SendCmd(setstatus+char(flag0)+char(flag1),2);
 end;
end;

procedure TForm1.SendIRcode1Click(Sender: TObject);
var slh,sll,sh,el,ehh,ehl,bl,b0,b1: byte;
    d1,d2,d3,d4: byte;
begin
 slh := 2; sll := 172; sh := 170;
 el := 22; ehh := 1; ehl := 1;
 bl := 22; b0 := 20; b1 := 62;
 d1 := $40; d2 := $BF; d3 := $30; d4 := $CF;
 SendCmd(setirbitcode+char(slh)+char(sll)+char(sh)+char(el)+char(ehh)+char(ehl)+char(bl)+char(b0)+char(b1),2);
 if nrcv = 2 then begin
  SendCmd(sendircode+char(d1)+char(d2)+char(d3)+char(d4),2);
 end else begin
 end;
end;

procedure TForm1.SendEpromIRcode1Click(Sender: TObject);
begin
 SendCmd(sendepromircode,2);
end;

procedure TForm1.SendFlashIRcode1Click(Sender: TObject);
begin
 SendCmd(sendeprgircode,2);
end;

procedure TForm1.UncheckkHz;
begin
 N30kHz1.Checked := false;
 N33kHz1.Checked := false;
 N36kHz1.Checked := false;
 N37kHz1.Checked := false;
 N38kHz1.Checked := false;
 N40kHz1.Checked := false;
 N56kHz1.Checked := false;
end;

procedure TForm1.N30kHz1Click(Sender: TObject);
begin
 flag0 := ir_30kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N33kHz1Click(Sender: TObject);
begin
 flag0 := ir_33kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N36kHz1Click(Sender: TObject);
begin
 flag0 := ir_36kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N37kHz1Click(Sender: TObject);
begin
 flag0 := ir_37kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N38kHz1Click(Sender: TObject);
begin
 flag0 := ir_38kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N40kHz1Click(Sender: TObject);
begin
 flag0 := ir_40kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;

procedure TForm1.N56kHz1Click(Sender: TObject);
begin
 flag0 := ir_56kHz;
 UpdateMenu(flag0,flag1);
 SendCmd(setstatus+char(flag0)+char(flag1),2);
end;



end.



