unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, inifiles, unit4, unitx;

type

  TStoreData = record
   FileName,data,res: string;
   timer: real;
  end;

  TForm3 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    data: TMemo;
    Label1: TLabel;
    irtimer: TEdit;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    res: TMemo;
    BitBtn3: TBitBtn;
    cb: TComboBox;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    sd: TSaveDialog;
    od: TOpenDialog;
    datax: TLabel;
    logic: TEdit;
    logichex: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure dataChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   filename: string;
   irt: tirtime;
   procedure DecodeLine(s: string; t: real);
   procedure UpdateIrt(irt: tirtime);
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}


const initsec='init';
      logicsec='logic';

procedure TForm3.FormCreate(Sender: TObject);
begin
 datax.Caption := '';
 logic.Text := '';
 logichex.Text := '';
 data.clear;
 res.clear;
 sd.InitialDir := _exedir;
 od.InitialDir := _exedir;
 ClearIRTime(irt);
end;

procedure TForm3.SpeedButton1Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then data.Clear;
end;

function GetVal(var s,o: string): integer;
var i: integer;
    ph,pl: string;
    h,l: integer;
begin
 s := trim(s);
 i := Pos(' ',s);
 if i <> 0 then begin
  ph := system.copy(s,1,i-1);
  system.delete(s,1,i);
 end else begin
  ph := s; s := '';
 end;

 s := trim(s);
 i := Pos(' ',s);
 if i <> 0 then begin
  pl := system.copy(s,1,i-1);
  system.delete(s,1,i);
 end else begin
  pl := s; s := '';
 end;
 o := ph + ' ' + pl;
 h := strtointdef('0x'+ph,-1)*256;
 l := strtointdef('0x'+pl,-1);
 if (h < 0) or (l < 0) then result := -1 else result := h + l;
end;

procedure TForm3.DecodeLine(s: string; t: real);
var r,o: string;
    b,i: integer;
    hilo: boolean;
    tm: real;
const hilochars: array [0..1] of char = ('/','\');
label cont;
begin
 r := ''; i := 0; hilo := true;
 repeat
  b := GetVal(s,o);
  if (b < 0) then begin
   ebox(format('Data error %s! Index %d',[o,i]));
   break;
  end else begin
   tm := t*b;
   if (tm > 100) and (i = 0) then begin
    if qbox(format('Ignore first data time %s [%0.2fms]?',[o,tm])) = idyes then goto cont;
   end;
    r := r + hilochars[byte(hilo)] + format('%0.2f',[tm]);
    hilo := not hilo;
  end;
cont:
  inc(i);
 until s = '';
 if r <> '' then res.Lines.Add(r);
 if s <> '' then ebox(s);
end;


procedure TForm3.BitBtn1Click(Sender: TObject);
var s1: string;
    t: real;
begin
 s1 := trim(data.text);
 if s1 = '' then exit;
 ClearIRTime(irt);
 res.clear;
 t := strtofloat(trim(irtimer.Text))*1000;
 DecodeLine(s1,t);
 datax.Caption := '';
 logic.Text := '';
 if res.text <> '' then begin
  calcdata(res.text,irt);
  updateirt(irt);
 end;
end;

procedure TForm3.BitBtn3Click(Sender: TObject);
var f: TForm4;
begin
 if trim(res.text) = '' then exit;
 f := UpdateGraph(filename,res.text, self);
 cb.Items.Add(f.caption);
 UpdateIrt(f.irt);
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
 DestroyGraphs;
end;

procedure TForm3.cbClick(Sender: TObject);
var w: thandle;
begin
 w := findwindow('TForm4',PChar(cb.Text));
 if w <> 0 then begin
  showwindow(w,sw_show);
  setactivewindow(w);
 end else ebox('"'+cb.Text+'" not found!');
end;

procedure LoadData(f: string; var d: tstoredata; var irt: tirtime);
var i: tinifile;
begin
 d.filename := f;
 i := TIniFile.Create(f);
try
 d.data := i.ReadString(initsec,'DataTimer','');
 d.res := i.ReadString(initsec,'Result','');
 d.timer := i.ReadFloat(initsec,'Timer',0.000001);
 irt.s0 := i.ReadFloat(logicsec,'Start0',0);
 irt.s1 := i.ReadFloat(logicsec,'Start1',0);
 irt.e0 := i.ReadFloat(logicsec,'Stop0',0);
 irt.e1 := i.ReadFloat(logicsec,'Stop1',0);
 irt.bits := i.ReadFloat(logicsec,'BitS',0);
 irt.bit0 := i.ReadFloat(logicsec,'Bit0',0);
 irt.bit1 := i.ReadFloat(logicsec,'Bit1',0);
 irt.logic := i.ReadString(logicsec,'Data','');
 irt.logicHex := i.ReadString(logicsec,'DataHex','');
 irt.protocol := TIRProtocol(i.ReadInteger(logicsec,'protocol',0));
finally
 i.free;
end;
end;

procedure SaveData(f: string; d: tstoredata; irt: tirtime);
var i: tinifile;
begin
 d.filename := f;
 i := TIniFile.Create(f);
try
 i.WriteString(initsec,'DataTimer',d.data);
 i.WriteString(initsec,'Result',d.res);
 i.WriteString(initsec,'Timer',format('%1.10f',[d.timer]));
 i.WriteString(logicsec,'Start0',format('%1.2f',[irt.s0]));
 i.WriteString(logicsec,'Start1',format('%1.2f',[irt.s1]));
 i.WriteString(logicsec,'Stop0',format('%1.2f',[irt.e0]));
 i.WriteString(logicsec,'Stop1',format('%1.2f',[irt.e1]));
 i.WriteString(logicsec,'BitS',format('%1.2f',[irt.bits]));
 i.WriteString(logicsec,'Bit0',format('%1.2f',[irt.bit0]));
 i.WriteString(logicsec,'Bit1',format('%1.2f',[irt.bit1]));
 i.WriteString(logicsec,'Data',irt.logic);
 i.WriteString(logicsec,'DataHex',irt.logicHex);
 i.WriteInteger(logicsec,'protocol',byte(irt.protocol));
finally
 i.free;
end;
end;

procedure TForm3.BitBtn4Click(Sender: TObject);
var d: TStoreData;
begin
 if sd.Execute then begin
  d.data := trim(data.text);
  d.res := trim(res.text);
  d.timer := strtofloat(trim(irtimer.text));
  SaveData(sd.filename,d, irt);
 end;
end;

procedure TForm3.UpdateIrt(irt: tirtime);
var s: string;
begin
  s := format('Start 0 : %1.2f'#13+
              'Start 1 : %1.2f'#13#13+
              'Stop 0  : %1.2f'#13+
              'Stop 1  : %1.2f'#13#13+
              'Bit S   : %1.2f'#13+
              'Bit 0   : %1.2f'#13+
              'Bit 1   : %1.2f'#13#13+
              'Protocol: %s',
              [irt.s0,irt.s1,irt.e0,irt.e1,irt.bits,irt.bit0,irt.bit1,IRProtoStr[irt.protocol]]);
  datax.Caption := s;
  logic.Text := irt.logic;
  logicHex.Text := irt.logicHex;
end;

procedure TForm3.BitBtn5Click(Sender: TObject);
var d: TStoreData;
begin
 if od.Execute then begin
  LoadData(od.filename,d, irt);
  data.text := d.data;
  res.text := trim(d.res);
  irtimer.text := format('%1.10f',[d.timer]);
  filename := d.FileName;
  if res.text <> '' then begin
   BitBtn3Click(Sender);
  end;
 end;
end;

procedure TForm3.dataChange(Sender: TObject);
begin
 filename := '';
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
 close;
end;

end.

