unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, unitx;


type

  TIRProtocol = (irp_unknown,irp_proto1,irp_proto2,irp_proto3);
  TBitType = (btnone,btstart,btstop,btbit);

  TIRBit = record
   time: real;
   bittype: TBitType;
  end;

  TVITime = record
   count: integer;
   time: real;
  end;

  TVITimeArray = array of TVITime;

  TIRTime = record
   count: integer;
   protocol: TIRProtocol;
   dm,hbit,s0,s1,e0,e1,bits,bit0,bit1: real;
   data,logic,logicHex: string;
   abit: array of TIRBit;
  end;

  TForm4 = class(TForm)
    img: TImage;
    sb: TScrollBar;
    PopupMenu1: TPopupMenu;
    Translatetologic1: TMenuItem;
    sd: TSaveDialog;
    procedure FormResize(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure sbChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Translatetologic1Click(Sender: TObject);
    procedure sbKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
   zoom: real;
   irt: tirtime;
   procedure DoUpdateGraph;
   procedure ResizePic(what: integer; Shift: TShiftState;MousePos: TPoint);
  end;

var
  frmcount: integer = 0;
  frm: array [0..1000] of TForm4;

const
  bleft = 20;
  bblank = 30;
  btop = 20;
  yheight = 100;
  maxzoom = 150;
  bitcounts: integer = 8;
  IRProtoStr: array [TIRProtocol] of string = ('Unknown','Proto1','Proto2','Proto3');

function UpdateGraph(c,s: string; owner: TComponent): pointer;
procedure DestroyGraphs;
procedure CalcData(s: string; var irt: tirtime);
procedure ClearIRTime(var irt: tirtime);

implementation

{$R *.DFM}

procedure CheckVI(var vi: TVITimeArray; m: real);
var i,j: integer;
    f: boolean;
begin
 f := false;
 i := length(vi);
 for j := 0 to i - 1 do begin
  if (m > vi[j].time - 0.1) and (m < vi[j].time + 0.1) then begin
//  if m = vi[j].time then begin
   vi[j].count := vi[j].count + 1; f := true; break;
  end;
 end;
 if not f then begin
  setlength(vi,i+1);
  vi[i].time := m;
  vi[i].count := 1;
 end;
end;

procedure AnalyseVal(var irt: tirtime);
var i,ii,ks0,ks1,ke0,ke1,ks,k0,k1,k,l: integer;
    d,m,mn,mx: real;
    lgh,sb: byte;
    vi: TVITimeArray;
begin
 ks0 := 0; ks1 :=0 ; ke0 := 0; ke1 := 0; ks := 0; k0 := 0; k1 := 0;
try
 irt.protocol := irp_unknown;
 irt.bits := 0; irt.bit0 := 0; irt.bit1 := 0;
 irt.s0 := 0; irt.s1 := 0;  irt.e0 := 0; irt.e1 := 0;
 l := irt.count; irt.dm := 10; sb := 0;
 if (l > 2) then begin
  d := irt.abit[0].time/irt.abit[1].time;
  if (((d+0.1) >= 2) and ((d-0.1) <= 2)) or
     (((d+0.1) >= 0.5) and ((d-0.1) <= 0.5)) then begin
   inc(ks0); irt.s0 := irt.abit[0].time;
   irt.abit[0].bittype := btstart;
   inc(ks1); irt.s1 := irt.abit[1].time;
   irt.abit[1].bittype := btstart;
   if (irt.s1 <> 0) and (irt.s1 < irt.s0) then irt.dm := irt.s1 else irt.dm := irt.s0;
   irt.dm := irt.dm - 0.1;
   irt.protocol := irp_proto1;
   sb := 2;
  end else
  if (d < 1.5) then begin
   irt.protocol := irp_proto2;  // no start bit
  end else
  if (d > 4.5) then begin
   irt.protocol := irp_proto3; // only s0 start bit
   inc(ks0); irt.s0 := irt.abit[0].time;
   irt.abit[0].bittype := btstart;
   irt.dm := irt.s0 - 0.1;
   sb := 1;
  end;
 end;

 setlength(vi,0);
 mn := 1000; mx := 0;
 for i := sb to l-1 do begin
  if irt.abit[i].time < irt.dm then begin
    m := irt.abit[i].time;
    if m < mn then mn := m;
    if m > mx then mx := m;
    CheckVI(vi,m);  // values incidence
  end;
 end;

 k := length(vi);
 if k > 3 then begin
  irt.protocol := irp_unknown;
 end else if k > 2 then begin
  m := 1000; mn := 1000;
  for i := 0 to k-1 do if vi[i].time < m then m := vi[i].time;
  for i := 0 to k-1 do
   if (vi[i].time > m) and (vi[i].time < mn) then mn := vi[i].time;
 end;
 setlength(vi,0);

 irt.hbit := (mx + mn) / 2;
 irt.logic := ''; irt.logicHex := ''; lgh := 0;
 k := 1;

 i := sb;
 while i < l do begin
  ii := i + 1;
  if (irt.protocol <> irp_proto3) or
     ((irt.protocol = irp_proto3) and ((ii) < l) and (irt.abit[ii].time < irt.dm)) then begin
   inc(ks); irt.bits := irt.bits + irt.abit[i].time;
  end;
  irt.abit[i].bittype := btbit;
  if ((ii) < l) and (irt.abit[ii].time < irt.dm) then begin
   irt.abit[ii].bittype := btbit;
    if irt.abit[ii].time < irt.hbit then begin
     inc(k0); irt.bit0 := irt.bit0 + irt.abit[ii].time;
     irt.logic := irt.logic + '0';
    end else begin
     inc(k1); irt.bit1 := irt.bit1 + irt.abit[ii].time;
     irt.logic := irt.logic + '1';
     lgh := lgh + (1 shl (8-k));
    end;
   inc(k);
   if (k > 8) or ((ii+2) >= l) then begin
    irt.logic := irt.logic + ' '; k := 1;
    irt.logicHex := irt.logicHex + '0x'+inttohex(lgh,2)+' ';
    lgh := 0;
   end;
  end else begin // stop bit
    if irt.protocol = irp_proto3 then begin
     inc(ke1); irt.e1 := irt.e1 + irt.abit[i].time;
     irt.abit[i].bittype := btstop;
     irt.logic := irt.logic + '- ';
     if ((ii) < l) and (irt.abit[ii].time > irt.dm ) then begin
      inc(ks0); irt.s0 := irt.s0 + irt.abit[ii].time;
      irt.abit[ii].bittype := btstart;
     end else dec(i);
    end else begin
     inc(ke0); irt.e0 := irt.e0 + irt.abit[i].time;
     irt.abit[i].bittype := btstop;
     if ((ii) < l) then begin
      inc(ke1); irt.e1 := irt.e1 + irt.abit[ii].time;
      irt.abit[ii].bittype := btstop;
      irt.logic := irt.logic + '- ';
     end;
     if (irt.abit[0].bittype = btstart) and ((ii+1) < l) and
        (irt.abit[ii+1].time > (irt.abit[0].time-0.1)) then begin
      inc(ks0); irt.s0 := irt.s0 + irt.abit[ii+1].time;
      irt.abit[ii+1].bittype := btstart; inc(i);
      if ((i+2) < l) and (irt.abit[1].bittype = btstart) then begin
       inc(ks1); irt.s1 := irt.s1 + irt.abit[ii+2].time;
       irt.abit[ii+2].bittype := btstart; inc(i);
      end;
     end;
    end;

  end;
  inc(i,2);
 end;
 if ks0 > 0 then irt.s0 := irt.s0/ks0 else irt.s0 := 0;
 if ks1 > 0 then irt.s1 := irt.s1/ks1 else irt.s1 := 0;
 if ke0 > 0 then irt.e0 := irt.e0/ke0 else irt.e0 := 0;
 if ke1 > 0 then irt.e1 := irt.e1/ke1 else irt.e1 := 0;
 if ks <> 0 then irt.bits := irt.bits/ks else irt.bits := 0;
 if k0 <> 0 then irt.bit0 := irt.bit0/k0 else irt.bit0 := 0;
 if k1 <> 0 then irt.bit1 := irt.bit1/k1 else irt.bit1 := 0;
except
 on e: exception do ebox(e.message);
end;
end;

procedure CalcData(s: string; var irt: tirtime);
var i,j: integer;
    r: real;
    n: string;
begin
 irt.data := trim(s);
 irt.count := 0; setlength(irt.abit,0);
 if s = '' then exit;
 while s <> '' do begin
  i := pos('\',s); j := pos('/',s);
  if (i > 0) and (i < j) then begin
   n := trim(copy(s,2,j-2)); delete(s,1,j-1); s := trim(s);
  end;
  if (j > 0) and (j < i) then begin
   n := trim(copy(s,2,i-2)); delete(s,1,i-1); s := trim(s);
  end;
  if (j = 0) or (i = 0) then begin
   n := trim(copy(s,2,1024)); s := '';
  end;
try
  r := strtofloat(n);
  inc(irt.count); setlength(irt.abit,irt.count);
  irt.abit[irt.count-1].time := r;
  irt.abit[irt.count-1].bittype := btnone;
except
 on e: exception do begin
  ebox(format('%s! Position %d',[e.message,irt.count]));
  exit;
 end;
end;
 end;
 AnalyseVal(irt);
end;

procedure ClearIRTime(var irt: tirtime);
begin
 irt.count := 0;
 irt.protocol := irp_unknown;
 irt.hbit := 0;
 irt.s0 := 0;
 irt.s1 := 0;
 irt.e0 := 0;
 irt.e1 := 0;
 irt.bits := 0;
 irt.bit0 := 0;
 irt.bit1 := 0;
 irt.logic := '';
 irt.data := '';
 setlength(irt.abit,0);
end;

procedure XRotateText(alg: integer; canvas: TCanvas; x, y: integer; angle: real; s: string; color: tcolor);
var
  lf: TLogFont;
  SaveFont: TFont;
  bkmode: integer;
begin
  SaveFont := TFont.Create;
  SaveFont.Assign(canvas.Font);
  GetObject(SaveFont.Handle, sizeof(TLogFont), @lf);
  lf.lfOrientation := 900 - round(angle * 10);
  lf.lfEscapement := lf.lfOrientation;
  canvas.Font.Handle := CreateFontIndirect(lf);
  bkmode := GetBkMode(canvas.Handle);
  SetBkMode(canvas.Handle, TRANSPARENT);
  SetBkColor(canvas.handle, clRed);
  SetTextColor(canvas.handle, color);
  SetTextAlign(canvas.handle, alg);
  canvas.TextOut(x, y, s);
  SetBkMode(canvas.Handle, bkmode);
  canvas.Font.Assign(SaveFont);
  SaveFont.Free;
end;


function UpdateGraph(c,s: string; owner: TComponent): pointer;
var f: TForm4;
begin
 f := TForm4.Create(owner);
 inc(frmcount);
 frm[frmcount] := f;
 f.Caption := f.Caption + ' ' + inttostr(frmcount)+' '+c;
 CalcData(s,f.irt);
 f.DoUpdateGraph;
 result := f;
end;

procedure DestroyGraphs;
begin
 while frmcount > 0 do begin
  TForm4(frm[frmcount]).Free;
  dec(frmcount);
 end;
end;

procedure UpdateGrp(form: TForm4);
var r,k,x,xx,fs,bt,bn: integer;
    hilo,ur: boolean;
    tt: real;
    canvas: tcanvas;
begin
 hilo := true;
 canvas := form.img.canvas;
 Canvas.Pen.Color := clRed;
 Canvas.Pen.Width := 2;
 Canvas.Brush.Color := clWhite;
 Canvas.FillRect(form.img.ClientRect);
 if form.irt.count = 0 then exit;

 canvas.Font.Name := 'Arial Narrow';
 Canvas.Font.Style := [fsBold];
 fs := round(form.zoom/2.5);  // z25=12
 if fs < 8 then fs := 8; // if fs > 32 then fs := 32;
 Canvas.Font.Size := fs;

 x := bleft - form.sb.Position;
 Canvas.MoveTo(x,btop);
 x := x + bblank;
 Canvas.LineTo(x,btop);
 tt := 0; bn := 0; bt := -1;
 for k := 0 to form.irt.count-1 do begin
  r := round(form.irt.abit[k].time*form.zoom);
  tt := tt + form.irt.abit[k].time;
  if Canvas.Font.Size > 16 then Canvas.Font.Size := 16;
  XRotateText(TA_TOP, canvas,x+r,btop+yheight+100,0, format('%1.2f',[tt]), clBlue);
  xx := canvas.TextHeight('0') div 3;
  xx := x + xx + r div 2;
  Canvas.Font.Size := fs;
  XRotateText(TA_BASELINE,canvas,xx,btop+yheight+40,0, format('%1.2f',[form.irt.abit[k].time]), clBlack);

  Canvas.MoveTo(x,btop);
  if form.irt.protocol = irp_proto3 then ur := hilo = false else ur := hilo = true;
  if ur then begin
   if form.irt.protocol <> irp_unknown then begin
    if (form.irt.abit[k].bittype <> btbit) then bt := -1; // start/stop bit
    if (form.irt.abit[k].bittype = btbit) then begin
     inc(bt);
     if (bt mod bitcounts = 0) then begin
      Canvas.Pen.Width := 1; Canvas.Pen.Color := clBlack; Canvas.LineTo(x,0);
      if form.irt.abit[k].bittype = btbit then begin
       inc(bn);
       Canvas.Font.Size := 10;
       XRotateText(TA_BASELINE,canvas,x+3,btop-6,90,inttostr(bn), clTeal);
       Canvas.Font.Size := fs;
      end;
      Canvas.Pen.Width := 2; Canvas.MoveTo(x,btop);
     end;
    end;
   end;
  end;

  case form.irt.abit[k].bittype of
   btbit:  Canvas.Pen.Color := clRed;
   btstart:Canvas.Pen.Color := clFuchsia;
   btstop: Canvas.Pen.Color := clPurple;
  end;
  if hilo then begin   // draw |_|
   hilo := false;
   Canvas.LineTo(x,btop+yheight);
   x := x+r; Canvas.LineTo(x,btop+yheight); Canvas.LineTo(x,btop);
  end else begin // draw ------
   hilo := true;
   x := x+r; Canvas.LineTo(x,btop);
  end;
 end;

 Canvas.Pen.Color := clRed;
 Canvas.LineTo(x+bblank,btop);
 Canvas.Font.Size := 12;
 XRotateText(TA_BASELINE,canvas,10,btop+20,90,'Zoom', clBlue);
 XRotateText(TA_BASELINE,canvas,10,btop+40,90,format('%1.1f',[form.zoom]) , clBlue);
 Canvas.Font.Size := 16;
 if form.irt.protocol <> irp_unknown then begin
  XRotateText(TA_BASELINE,canvas,bleft,btop+yheight+130,90,form.irt.logic, clBlack);
  XRotateText(TA_BASELINE,canvas,bleft,btop+yheight+155,90,form.irt.logicHex, clBlack);
 end;
end;


procedure TForm4.DoUpdateGraph;
begin
 UpdateGrp(self);
 show;
end;

procedure CalcWidth(var w: real; irt: TIRTime; zoom: real);
var i,k: integer;
begin
 k := irt.count;
 if k = 0 then begin
  w := 0;
 end else begin
  w := 0; for i := 0 to k-1 do w := w + irt.abit[i].time*zoom;
  w := w + 2*(bleft+bblank);
 end;
end;

procedure TForm4.FormResize(Sender: TObject);
var j: integer;
    w: real;
begin
 img.Picture.Bitmap.Height := img.Height;
 img.Picture.Bitmap.Width := img.Width;
 CalcWidth(w,irt,zoom);
 j := round(w - img.Width); if j < 0 then j := 0; sb.Max := j;
 UpdateGrp(self);
end;

procedure TForm4.ResizePic(what: integer; Shift: TShiftState;MousePos: TPoint);
var i,w,z: real;
    p: TPoint;
    x,j: integer;
begin
 z := zoom;
 if ssCtrl in shift then i := 5.0 else i := 0.5;
 if what > 0 then begin
  if zoom < maxzoom then begin
   zoom := zoom+i;
  end;
 end else begin
  if zoom >= 1.5 then begin
   zoom := zoom-i;
   if zoom < 1 then zoom := 1;
  end;
 end;
 CalcWidth(w,irt,zoom);
 j := round(w - img.Width); if j < 0 then j := 0; sb.Max := j;
 p := img.ScreenToClient(MousePos);
 if ((p.y > 0) and (p.y < img.Height)) and ((p.x > 0) and (p.x < img.width)) then begin
  if (j = 0) then begin

  end else
  if zoom <> z then begin
   x := sb.Position-bleft-bblank+p.x;
   sb.Position := round(x*zoom/z - p.x)+bleft+bblank;
  end;
 end;
 UpdateGrp(self);
end;

procedure TForm4.sbKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
  107: begin // +
  end;
  109: begin // -
  end;
  37: begin // left
  end;
  38: begin // up
   ResizePic(1,shift,Point(img.left,img.top));
  end;
  39: begin // right
  end;
  40: begin // down
   ResizePic(-1,shift,Point(img.left,img.top));
  end;
  end;
end;

procedure TForm4.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
 ResizePic(WheelDelta, Shift, MousePos); Handled := true;
end;

procedure TForm4.sbChange(Sender: TObject);
begin
 UpdateGrp(self);
end;

procedure TForm4.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 canclose := false;
 showwindow(handle, sw_hide);
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
 zoom := 7.0;
 clearirtime(irt);
end;

procedure TForm4.FormDestroy(Sender: TObject);
begin
//
end;

procedure TForm4.Translatetologic1Click(Sender: TObject);
var s: string;
begin
 s := format('Start 0: %1.2f   Start 1: %1.2f'#13#13+
             'Stop 0: %1.2f   Stop 1: %1.2f'#13#13+
             'Bit S: %1.2f   Bit 0: %1.2f   Bit 1: %1.2f'#13#13+
             'Logic: %s'#13#13+
             'LogicHex: %s'#13#13+
             'Detected protocol: %s',
  [irt.s0,irt.s1,irt.e0,irt.e1,irt.bits,irt.bit0,irt.bit1,irt.logic,irt.logicHex,IRProtoStr[irt.protocol]]);
 ibox(s);
end;






end.

